/*
 *  ScanGear MP for Linux
 *  Copyright CANON INC. 2007-2010
 *  All Rights Reserved.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; version 2 of the License.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
 *
 * NOTE:
 *  - As a special exception, this program is permissible to link with the
 *    libraries released as the binary modules.
 *  - If you write modifications of your own for these programs, it is your
 *    choice whether to permit this exception to apply to your modifications.
 *    If you do not wish that, delete this exception.
*/


#ifndef _canon_mfp_opts_h_
#define _canon_mfp_opts_h_

/* for options */
/* +++ NAME +++ */
#define CANON_NAME_NUM_OPTS			""
#define CANON_NAME_PREVIEW			"preview"
#define CANON_NAME_SCAN_MODE		"mode"
#define CANON_NAME_RES_BIND			"resolution-bind"
#define CANON_NAME_RES				"resolution"
#define CANON_NAME_RES_X			"resolution"
#define CANON_NAME_RES_Y			"y-resolution"
#define CANON_NAME_MARGINS			""
#define CANON_NAME_MARGINS_TL_X		"tl-x"
#define CANON_NAME_MARGINS_TL_Y		"tl-y"
#define CANON_NAME_MARGINS_BR_X		"br-x"
#define CANON_NAME_MARGINS_BR_Y		"br-y"

#define CANON_NAME_EXTEND			""
#define CANON_NAME_EX_GET_STATUS		"canon-get-status"
#define CANON_NAME_EX_GET_CAL_STATUS	"canon-get-cal-status"
#define CANON_NAME_EX_GET_ABILITY_VER	"canon-get-ability-ver"
#define CANON_NAME_EX_GET_ABILITY		"canon-get-ability"
#define CANON_NAME_EX_USE_AREA_PIXEL	"canon-area-pixel"
#define CANON_NAME_EX_TL_X_PIXEL		"canon-tl-x-pixel"
#define CANON_NAME_EX_TL_Y_PIXEL		"canon-tl-y-pixel"
#define CANON_NAME_EX_BR_X_PIXEL		"canon-br-x-pixel"
#define CANON_NAME_EX_BR_Y_PIXEL		"canon-br-y-pixel"
#define CANON_NAME_EX_GAMMA				"canon-gamma"
/* Ver.1.20 - */
#define CANON_NAME_EX_EVERY_CALIBRATION		"canon-every-calibration"
#define CANON_NAME_EX_SILENT				"canon-silent"
/* Ver.1.30 - */
#define CANON_NAME_EX_SCAN_METHOD		"canon-scan-method"

/* +++ TITLE +++ */
#define CANON_TITLE_NUM_OPTS		""
#define CANON_TITLE_PREVIEW			"Preview"
#define CANON_TITLE_SCAN_MODE		"Scan Mode"
#define CANON_TITLE_RES_BIND		"Bind X-Y Resolution"
#define CANON_TITLE_RES				"Scan Resolution"
#define CANON_TITLE_RES_X			"X Resolution"
#define CANON_TITLE_RES_Y			"Y Resolution"
#define CANON_TITLE_MARGINS			"Scan Margins"
#define CANON_TITLE_MARGINS_TL_X	"Top-Left X"
#define CANON_TITLE_MARGINS_TL_Y	"Top-Left Y"
#define CANON_TITLE_MARGINS_BR_X	"Bottom-Right X"
#define CANON_TITLE_MARGINS_BR_Y	"Bottom-Right Y"

#define CANON_TITLE_EXTEND				"Extend options"
#define CANON_TITLE_EX_GET_STATUS		"Get Scanner Status"
#define CANON_TITLE_EX_GET_CAL_STATUS	"Get Calibration Status"
#define CANON_TITLE_EX_GET_ABILITY_VER	"Get Ability-struct Version"
#define CANON_TITLE_EX_GET_ABILITY		"Get Scanner Ability"
#define CANON_TITLE_EX_USE_AREA_PIXEL	"Use unit pixel"
#define CANON_TITLE_EX_TL_X_PIXEL		"Top-Left X (pixel)"
#define CANON_TITLE_EX_TL_Y_PIXEL		"Top-Left Y (pixel)"
#define CANON_TITLE_EX_BR_X_PIXEL		"Bottom-Right X (pixel)"
#define CANON_TITLE_EX_BR_Y_PIXEL		"Bottom-Right Y (pixel)"
#define CANON_TITLE_EX_GAMMA			"Set Gamma Table"
/* Ver.1.20 - */
#define CANON_TITLE_EX_EVERY_CALIBRATION	"Every Calibration setting"
#define CANON_TITLE_EX_SILENT				"Silent scan setting"
/* Ver.1.30 - */
#define CANON_TITLE_EX_SCAN_METHOD		"Scan Method"

/* +++ DESC +++ */
#define CANON_DESC_NULL				""


#endif /* not _canon_mfp_opts_h_ */

